# Extensions

The following extensions are available globally.

### Standard Types:

- `NSAttributeType`
  See more

  #### Declaration

  Swift

      enum NSAttributeType : UInt

- `NSDeleteRule`
  See more

  #### Declaration

  Swift

      enum NSDeleteRule : UInt

- `Result`
  See more

  #### Declaration

  Swift

      @_frozen
      enum Result<Success, Failure> where Failure : Error

- `Selector`
  See more

  #### Declaration

  Swift

      struct Selector : ExpressibleByStringLiteral

### KeyPathString

- `KeyPathString`
  See more

  #### Declaration

  Swift

      public typealias KeyPathString = String

### KeyPath: DynamicKeyPath

- `KeyPath`
  See more

  #### Declaration

  Swift

      class KeyPath<Root, Value> : PartialKeyPath<Root>

### NSManagedObject

- `NSManagedObject`
  See more

  #### Declaration

  Swift

      class NSManagedObject : NSObject

### RawRepresentable

- `RawRepresentable`
  See more

  #### Declaration

  Swift

      protocol RawRepresentable

### NSManagedObjectContext

- `NSManagedObjectContext`
  See more

  #### Declaration

  Swift

      class NSManagedObjectContext : NSObject, NSCoding, NSLocking

### Sequence where Iterator.Element: OrderByClause

- `Sequence`
  See more

  #### Declaration

  Swift

      protocol Sequence

### Progress

- `Progress`
  See more

  #### Declaration

  Swift

      class Progress : NSObject

### Bool

- `Bool`
  See more

  #### Declaration

  Swift

      struct Bool

### CGFloat

- `CGFloat`
  See more

  #### Declaration

  Swift

      struct CGFloat

### Data

- `Data`
  See more

  #### Declaration

  Swift

      struct Data : ReferenceConvertible, Equatable, Hashable, RandomAccessCollection, MutableCollection, RangeReplaceableCollection, MutableDataProtocol, ContiguousBytes

### Date

- `Date`
  See more

  #### Declaration

  Swift

      struct Date : ReferenceConvertible, Comparable, Equatable

### Double

- `Double`
  See more

  #### Declaration

  Swift

      struct Double

### Float

- `Float`
  See more

  #### Declaration

  Swift

      struct Float

### Int

- `Int`
  See more

  #### Declaration

  Swift

      struct Int : FixedWidthInteger, SignedInteger

### Int8

- `Int8`
  See more

  #### Declaration

  Swift

      struct Int8 : FixedWidthInteger, SignedInteger

### Int16

- `Int16`
  See more

  #### Declaration

  Swift

      struct Int16 : FixedWidthInteger, SignedInteger

### Int32

- `Int32`
  See more

  #### Declaration

  Swift

      struct Int32 : FixedWidthInteger, SignedInteger

### Int64

- `Int64`
  See more

  #### Declaration

  Swift

      struct Int64 : FixedWidthInteger, SignedInteger

### NSData

- `NSData`
  See more

  #### Declaration

  Swift

      class NSData : NSObject, NSCopying, NSMutableCopying, NSSecureCoding

### NSDate

- `NSDate`
  See more

  #### Declaration

  Swift

      class NSDate : NSObject, NSCopying, NSSecureCoding

### NSManagedObjectID

- `NSManagedObjectID`
  See more

  #### Declaration

  Swift

      class NSManagedObjectID : NSObject, NSCopying

### NSNull

- `NSNull`
  See more

  #### Declaration

  Swift

      class NSNull : NSObject, NSCopying, NSSecureCoding

### NSNumber

- `NSNumber`
  See more

  #### Declaration

  Swift

      class NSNumber : NSValue

### NSString

- `NSString`
  See more

  #### Declaration

  Swift

      class NSString : NSObject, NSCopying, NSMutableCopying, NSSecureCoding

### NSURL

- `NSURL`
  See more

  #### Declaration

  Swift

      class NSURL : NSObject, NSSecureCoding, NSCopying

### NSUUID

- `NSUUID`
  See more

  #### Declaration

  Swift

      class NSUUID : NSObject, NSCopying, NSSecureCoding

### String

- `String`
  See more

  #### Declaration

  Swift

      struct String

### URL

- `URL`
  See more

  #### Declaration

  Swift

      struct URL : ReferenceConvertible, Equatable

### UUID

- `UUID`
  See more

  #### Declaration

  Swift

      @available(OSX 10.8, iOS 6.0, *)
      struct UUID : ReferenceConvertible, Hashable, Equatable, CustomStringConvertible